package controllers_pages

import (
	"main/mvc/models"
	"main/mvc/models/models_pages"
	"net/http"
)

// Обработчик главной страницы
func MainRuPageHandler(a *models.App) http.HandlerFunc {
	return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		var err error

		// Страничка рендерится только если ее нет в кэше
		pageData, ok := models.PagesCache.Get(models_pages.MainRuPageTmplName)
		if !ok {
			pageData, err = models_pages.RenderMainRuPage(a.Templates, a.Version)
			if err != nil {
				http.Error(w, err.Error(), http.StatusInternalServerError)
				return
			}
			models.PagesCache.Set(models_pages.MainRuPageTmplName, pageData)
		}

		sendMainRuPage(w, pageData.([]byte))
	})
}

// Отправляет страницу
func sendMainRuPage(w http.ResponseWriter, data []byte) {
	w.Header().Set("Content-Type", "text/html; charset=utf-8")
	w.WriteHeader(http.StatusOK)
	w.Write(data)
}
